/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2013 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * http://glassfish.java.net/public/CDDL+GPL_1_1.html
 * or packager/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at packager/legal/LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */
package com.actionbazaar.interfaces.web;

import com.actionbazaar.domain.Bid;
import java.util.logging.Logger;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;
import javax.json.Json;
import javax.json.stream.JsonGenerator;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.GenericType;
import javax.ws.rs.core.MediaType;

@WebServlet(name = "RestClientServlet", urlPatterns = {"/restclient"})
public class RestClientServlet extends HttpServlet {

    private static final long serialVersionUID = 1L;

    private final Logger logger = Logger.getLogger(this.getClass().getName());

    @Override
    public void service(ServletRequest request, ServletResponse response)
            throws IOException, ServletException {

        response.setContentType("text/html");

        PrintWriter out = response.getWriter();

        // Calculate URL given servlet URL
        String url = String.format("%s://%s:%s/%s/rest/bids",
                request.getScheme(),
                request.getServerName(),
                request.getServerPort(),
                request.getServletContext().getContextPath()
        );
        logger.info("Calculated Client URL: " + url);

        // Get the list of bids
        List<Bid> bids = getBids(url);

        // Display the list of bids
        out.printf("<h3>Pre-Bids: %s</h3>", bids.size());
        for (Bid bid : bids) {
            out.printf("<p>Deleting Bid: [%s] from  %s for \"%s\" at $%.2f</p>",
                    bid.getId(),
                    bid.getBidder(),
                    bid.getItem(),
                    bid.getAmount());
        }

        // Delete the bids
        if(!bids.isEmpty()) {
            deleteBids(bids, url);
        }

        // Get and display the list of bids to verify;
        bids = getBids(url);
        out.printf("<h3>Post-Bids: %s</h3>", bids.size());
        for (Bid bid : bids) {
            out.printf("<p>%s</p>", bid);
        }
    }

    /**
     * Return list of bids via REST call to URL
     *
     * @param url
     * @return List of Bid items
     */
    private List<Bid> getBids(String baseurl) {
        WebTarget target = ClientBuilder.newClient().target(baseurl);
        return target.request(MediaType.APPLICATION_JSON)
                .get(new GenericType<List<Bid>>() {
                });
    }

    /**
     * Delete the list of Bid items
     * @param bids 
     */
    private void deleteBids(List<Bid> bids, String baseurl) {
        String url_id = String.format("%s/{id}", baseurl);

        for (Bid bid : bids) {
            // Resolve template with Bid Id to remove
            WebTarget target = ClientBuilder.newClient()
                    .target(url_id)
                    .resolveTemplate("id", bid.getId());
            // Call Delete on request
            target.request().delete();
        }
    }
}
